VERSION 5.00
Begin VB.UserControl CTScrollContainer 
   BorderStyle     =   1  'Fixed Single
   CanGetFocus     =   0   'False
   ClientHeight    =   1755
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2295
   ControlContainer=   -1  'True
   ScaleHeight     =   117
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   153
   ToolboxBitmap   =   "CTScrollContainer.ctx":0000
End
Attribute VB_Name = "CTScrollContainer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 06/2008

Option Explicit

Dim ctrl As Control
Dim vPos As Long
Dim hPos As Long

Enum Border
    Kein = 0
    [Fest Einfach] = 1
End Enum

'Standard Eigenschaftswerte:
Const m_def_ScrollXValue = 0
Const m_def_ScrollYValue = 0
Const m_def_StartXValue = 0
Const m_def_StartYValue = 0

'Eigenschaft-Variablen:
Dim m_ScrollXValue As Long
Dim m_ScrollYValue As Long
Dim m_StartXValue As Long
Dim m_StartYValue As Long

Private Sub ChangeScrollX()

    For Each ctrl In UserControl.ContainedControls

        If hPos < m_ScrollXValue Then

            ctrl.Left = ctrl.Left + ((m_ScrollXValue - hPos) * _
                Screen.TwipsPerPixelX)

        Else

            ctrl.Left = ctrl.Left - ((hPos - m_ScrollXValue) * _
                Screen.TwipsPerPixelY)

        End If

    Next

    hPos = m_ScrollXValue
    UserControl.Refresh

End Sub

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR

    BackColor = UserControl.BackColor

End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)

    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"

End Property

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Border

    BorderStyle = UserControl.BorderStyle

End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Border)

    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"

End Property

Private Sub ChangeScrollY()

    For Each ctrl In UserControl.ContainedControls

        If vPos < m_ScrollYValue Then

            ctrl.Top = ctrl.Top + ((m_ScrollYValue - vPos) * Screen.TwipsPerPixelX)

        Else

            ctrl.Top = ctrl.Top - ((vPos - m_ScrollYValue) * Screen.TwipsPerPixelY)

        End If

    Next

    vPos = m_ScrollYValue
    UserControl.Refresh

End Sub

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean

    Enabled = UserControl.Enabled

End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)

    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"

End Property

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=UserControl,UserControl,-1,Picture
Public Property Get Picture() As Picture

    Set Picture = UserControl.Picture

End Property

Public Property Set Picture(ByVal New_Picture As Picture)

    Set UserControl.Picture = New_Picture

    PropertyChanged "Picture"

End Property

Public Property Get ScrollXValue() As Long

    ScrollXValue = m_ScrollXValue

End Property

Public Property Let ScrollXValue(ByVal New_ScrollXValue As Long)

    m_ScrollXValue = New_ScrollXValue
    PropertyChanged "ScrollXValue"
    ChangeScrollX

End Property

Public Property Get ScrollYValue() As Long

    ScrollYValue = m_ScrollYValue

End Property

Public Property Let ScrollYValue(ByVal New_ScrollYValue As Long)

    m_ScrollYValue = New_ScrollYValue
    PropertyChanged "ScrollYValue"
    ChangeScrollY

End Property

Public Property Get StartXValue() As Long

    StartXValue = m_StartXValue

End Property

Public Property Let StartXValue(ByVal New_StartXValue As Long)

    m_StartXValue = New_StartXValue
    PropertyChanged "StartXValue"
    hPos = m_StartXValue

End Property

Public Property Get StartYValue() As Long

    StartYValue = m_StartYValue

End Property

Public Property Let StartYValue(ByVal New_StartYValue As Long)

    m_StartYValue = New_StartYValue
    PropertyChanged "StartYValue"
    vPos = m_StartYValue

End Property

' Eigenschaften fr Benutzersteuerelement initialisieren
Private Sub UserControl_InitProperties()

    m_ScrollXValue = m_def_ScrollXValue
    m_ScrollYValue = m_def_ScrollYValue
    m_StartXValue = m_def_StartXValue
    m_StartYValue = m_def_StartYValue

End Sub

' Eigenschaftenwerte vom Speicher laden
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)

    Set Picture = PropBag.ReadProperty("Picture", Nothing)

    m_ScrollXValue = PropBag.ReadProperty("ScrollXValue", m_def_ScrollXValue)
    m_ScrollYValue = PropBag.ReadProperty("ScrollYValue", m_def_ScrollYValue)
    m_StartXValue = PropBag.ReadProperty("StartXValue", m_def_StartXValue)
    m_StartYValue = PropBag.ReadProperty("StartYValue", m_def_StartYValue)

End Sub

' Eigenschaftenwerte in den Speicher schreiben
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 1)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Picture", Picture, Nothing)
    Call PropBag.WriteProperty("ScrollXValue", m_ScrollXValue, m_def_ScrollXValue)
    Call PropBag.WriteProperty("ScrollYValue", m_ScrollYValue, m_def_ScrollYValue)
    Call PropBag.WriteProperty("StartXValue", m_StartXValue, m_def_StartXValue)
    Call PropBag.WriteProperty("StartYValue", m_StartYValue, m_def_StartYValue)

End Sub

